//
//  TailoringViewController.m
//  demo
//
//  Created by gg.lucy on 2018/10/10.
//  Copyright © 2018 王刚. All rights reserved.
//

#import "TailoringViewController.h"
#import "GGFont.h"
#import <Masonry.h>
#import <VPImageCropperViewController.h>
@interface TailoringViewController ()<UIImagePickerControllerDelegate,UINavigationControllerDelegate,VPImageCropperDelegate>

@end

@implementation TailoringViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor=[UIColor cyanColor];
    self.navigationItem.title=@"裁剪图片";
    
    [self.view addSubview:self.imageV];
    [self.imageV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.view.mas_top).with.offset(navigationBarHeight+10);
        make.size.mas_offset(CGSizeMake(80, 80));
        make.centerX.equalTo(self.view);
    }];
    [self.view addSubview:self.tailorBtn];
    [self.tailorBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.imageV.mas_bottom).with.offset(10);
        make.size.mas_offset(CGSizeMake(100, 30));
        make.centerX.equalTo(self.imageV);
    }];
}

#pragma mark-reload
-(UIImageView *)imageV{
    if (!_imageV) {
        _imageV=[UIImageView new];
        _imageV.backgroundColor=[UIColor yellowColor];
    }
    return _imageV;
}
-(UIButton *)tailorBtn{
    if (!_tailorBtn) {
        _tailorBtn=[UIButton new];
        [_tailorBtn setTitle:@"获取图片" forState:UIControlStateNormal];
        [_tailorBtn setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
        _tailorBtn.titleLabel.font=[GGFont ggFontWithSize:15];
        [_tailorBtn addTarget:self action:@selector(tailorBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _tailorBtn;
}
//-(VPImageCropperViewController *)imageController{
//    if (!_imageController) {
//        _imageController=[VPImageCropperViewController new];
//        _imageController.delegate=self;
//    }
//    return _imageController;
//}
#pragma mark-action
-(void)tailorBtnClick:(UIButton *)tailor{
    UIAlertController *alert = [UIAlertController alertControllerWithTitle:@"选择图片" message:nil preferredStyle:UIAlertControllerStyleActionSheet];
    UIAlertAction *photoAction = [UIAlertAction actionWithTitle:@"相册获取" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        // 获取用户的权限
        // 询问用户要求权限
        if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypePhotoLibrary]) {
            // 实例化图片选择器
            UIImagePickerController *imagePicker = [[UIImagePickerController alloc]init];
            /*
             UIImagePickerControllerSourceTypePhotoLibrary
             :图库
             UIImagePickerControllerSourceTypeCamera
             :相机
             UIImagePickerControllerSourceTypeSavedPhotosAlbum
             :相册
             */
            // 设置图片选择器的数据类型
            //
            imagePicker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
            // 设置代理
            imagePicker.delegate = self;
            
            // 进入图片选择器
            [self presentViewController:imagePicker animated:YES completion:nil];
        }else{
            NSLog(@"用户拒绝访问");
        }
    }];
    [alert addAction:photoAction];
    
    UIAlertAction *camaraAction = [UIAlertAction actionWithTitle:@"直接拍照" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        
        if ([UIImagePickerController isCameraDeviceAvailable:UIImagePickerControllerCameraDeviceRear]) {
            NSLog(@"存在摄像头");
            // 请求用户权限
            if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
                
                UIImagePickerController *picker = [[UIImagePickerController alloc]init];
                picker.sourceType = UIImagePickerControllerSourceTypeCamera;
                picker.delegate = self;
                [self presentViewController:picker animated:YES completion:nil];
                
            }else{
                NSLog(@"用户拒绝访问相机");
            }
        }else{
            NSLog(@"无有效摄像头可供使用");
        }
    }];
    [alert addAction:camaraAction];
    
    UIAlertAction *cancleAction = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
    }];
    [alert addAction:cancleAction];
    
    [self presentViewController:alert animated:YES completion:nil];
}


#pragma mark-delegate
-(void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary<NSString *,id> *)info{
    [picker dismissViewControllerAnimated:YES completion:^() {
        UIImage *portraitImg = [info objectForKey:@"UIImagePickerControllerOriginalImage"];
        portraitImg = [self imageByScalingToMaxSize:portraitImg];
        // 裁剪
        VPImageCropperViewController *imgEditorVC = [[VPImageCropperViewController alloc] initWithImage:portraitImg cropFrame:CGRectMake(0, 100.0f, kScreenWidth, kScreenWidth) limitScaleRatio:3.0];
        imgEditorVC.delegate = self;
        [self presentViewController:imgEditorVC animated:YES completion:^{
            // TO DO
        }];
    }];
}
- (UIImage *)imageByScalingToMaxSize:(UIImage *)sourceImage {
    if (sourceImage.size.width < kScreenWidth) return sourceImage;
    CGFloat btWidth = 0.0f;
    CGFloat btHeight = 0.0f;
    if (sourceImage.size.width > sourceImage.size.height) {
        btHeight = kScreenWidth;
        btWidth = sourceImage.size.width * (kScreenWidth / sourceImage.size.height);
    } else {
        btWidth = kScreenWidth;
        btHeight = sourceImage.size.height * (kScreenWidth / sourceImage.size.width);
    }
    CGSize targetSize = CGSizeMake(btWidth, btHeight);
    return [self imageByScalingAndCroppingForSourceImage:sourceImage targetSize:targetSize];
}
- (UIImage *)imageByScalingAndCroppingForSourceImage:(UIImage *)sourceImage targetSize:(CGSize)targetSize {
    UIImage *newImage = nil;
    CGSize imageSize = sourceImage.size;
    CGFloat width = imageSize.width;
    CGFloat height = imageSize.height;
    CGFloat targetWidth = targetSize.width;
    CGFloat targetHeight = targetSize.height;
    CGFloat scaleFactor = 0.0;
    CGFloat scaledWidth = targetWidth;
    CGFloat scaledHeight = targetHeight;
    CGPoint thumbnailPoint = CGPointMake(0.0,0.0);
    if (CGSizeEqualToSize(imageSize, targetSize) == NO)
    {
        CGFloat widthFactor = targetWidth / width;
        CGFloat heightFactor = targetHeight / height;
        
        if (widthFactor > heightFactor)
            scaleFactor = widthFactor; // scale to fit height
        else
            scaleFactor = heightFactor; // scale to fit width
        scaledWidth  = width * scaleFactor;
        scaledHeight = height * scaleFactor;
        
        // center the image
        if (widthFactor > heightFactor)
        {
            thumbnailPoint.y = (targetHeight - scaledHeight) * 0.5;
        }
        else
            if (widthFactor < heightFactor)
            {
                thumbnailPoint.x = (targetWidth - scaledWidth) * 0.5;
            }
    }
    UIGraphicsBeginImageContext(targetSize); // this will crop
    CGRect thumbnailRect = CGRectZero;
    thumbnailRect.origin = thumbnailPoint;
    thumbnailRect.size.width  = scaledWidth;
    thumbnailRect.size.height = scaledHeight;
    
    [sourceImage drawInRect:thumbnailRect];
    
    newImage = UIGraphicsGetImageFromCurrentImageContext();
    if(newImage == nil) NSLog(@"could not scale image");
    
    //pop the context to get back to the default
    UIGraphicsEndImageContext();
    return newImage;
}
//裁剪完调用
-(void)imageCropper:(VPImageCropperViewController *)cropperViewController didFinished:(UIImage *)editedImage{
    self.imageV.image=editedImage;
    [cropperViewController dismissViewControllerAnimated:YES completion:^{
        
    }];
}
//取消裁剪调用
-(void)imageCropperDidCancel:(VPImageCropperViewController *)cropperViewController{
    [cropperViewController dismissViewControllerAnimated:YES completion:^{
        
    }];
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
